﻿Public Class Form1

  Dim BitMap1 As Bitmap
  Dim playtune As Boolean = False
  Dim x, y, ox, oy As Integer
  Dim OrgX, OrgY As Integer
  Dim mode, equation As Integer
  Dim p, A As Single
  Dim bcol As Color = Color.LightYellow
  Dim fcol As Color = Color.Blue ' chaos diagram
  Dim Pen1 As New Pen(Color.Blue) ' lines
  Dim Pen2 As New Pen(Color.Red)
  Dim Pen3 As New Pen(Color.LightSalmon)
  Dim Pen4 As New Pen(Color.Black) ' axes

  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    BitMap1 = New Bitmap(PictureBox1.Width, PictureBox1.Height)
    PictureBox1.BackgroundImage = BitMap1
    OrgX = 40
    OrgY = PictureBox1.Height - 40
    Timer1.Interval = 150
    Timer1.Start()
    mode = 1 : equation = 1
    RadioButton1.Checked = True
    RadioButton6.Checked = True
    NumericUpDown1.Value = 2.8
    NumericUpDown4.Value = 0.1
  End Sub

  Private Sub PictureBox1_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBox1.MouseEnter
    If mode = 1 And CheckBox1.Checked Then playtune = True
  End Sub

  Private Sub PictureBox1_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBox1.MouseLeave
    playtune = False
  End Sub

  Private Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
    If playtune Then
      Dim S As Single = NumericUpDown1.Value
      Dim x As Integer = Cursor.Position.X - Me.Location.X - 12 - OrgX
      x = Limit(x, 0, 640)
      A = 4 - (4 - S) * (1 - x / 640)
      p = NumericUpDown4.Value
      For i As Integer = 1 To 200
        p = Iterate(A, p, 1)
      Next
    End If
  End Sub

  Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
    ' e.Graphics.TranslateTransform(OrgX, OrgY) ' set origin
    ' e.Graphics.ScaleTransform(1, -1) ' reverse Y coords
  End Sub

  Private Sub RePlot()
    PlotAxes()
    Select mode
      Case 0
        ChaosDiagram()
        CheckBox1.Enabled = True
      Case Else
        OrderDiagram(mode)
        CheckBox1.Enabled = False
    End Select
    PictureBox1.Invalidate()
  End Sub

  Private Sub ChaosDiagram()
    Dim S As Single = NumericUpDown1.Value
    For x As Integer = 0 To 640
      A = S + x * (4 - S) / 640
      p = NumericUpDown4.Value
      For i As Integer = 1 To 200
        p = Iterate(A, p, 1)
      Next
      For i As Integer = 1 To 200
        p = Iterate(A, p, 1)
        PlotBackgroundPoint(x, 480 * p, fcol)
      Next
    Next
  End Sub

  Private Sub OrderDiagram(ByVal order As Integer)
    A = NumericUpDown1.Value
    ox = 0 : oy = 0
    PlotBackgroundLine(Pen3, 480, 480)
    ox = 0 : oy = 0
    For x As Integer = 0 To 480 Step 4
      p = x / 480
      p = Iterate(A, p, order)
      PlotBackgroundLine(Pen1, x, 480 * p)
    Next
    p = NumericUpDown4.Value
    ox = 0 : oy = 480 * p
    For i As Integer = 1 To 100
      PlotBackgroundLine(Pen2, oy, oy)
      p = Iterate(A, p, order)
      PlotBackgroundLine(Pen2, ox, 480 * p)
    Next
    For i As Integer = 1 To 480
      p = Iterate(A, p, 1)
      ox = 540 : oy = 480 * p
      PlotBackgroundLine(Pen1, 640, oy)
    Next
  End Sub

  Private Function Iterate(ByVal A As Single, ByVal p As Single, ByVal o As Integer) As Single
    For i As Integer = 1 To o
      Select Case equation
        Case 1
          p = A * p * (1 - p)
        Case 2
          p = A * Math.Sin(p * Math.PI) / 4
        Case 3
          p = 4 * A * p * (p - 0.5) * (p - 1) + p
        Case 4
          p = A * (p / 2 + (p > 0.5) * (p - 0.5))
        Case 5
          p = 1 - A * p * (1 - p)
      End Select
    Next
    Return p
  End Function

  Private Sub PlotAxes()
    ClearBackground()
    ox = 0 : oy = 0
    If mode = 0 Then
      PlotBackgroundLine(Pen4, 640, 0)
    Else
      PlotBackgroundLine(Pen4, 480, 0)
    End If
    ox = 0 : oy = 0 : PlotBackgroundLine(Pen4, 0, 480)
  End Sub

  Private Sub ResetButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    RePlot()
  End Sub

  Private Sub StartStopButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

  End Sub

  Private Sub HelpButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
    Form2.Show()
    '  Dim f As String = My.Application.Info.DirectoryPath & "\Main.html"
    '  If IO.File.Exists(f) Then
    '    Process.Start(f)
    '  Else
    '    MsgBox("I cannot find a help file")
    '  End If
  End Sub

  Private Function ArcTangent(ByVal y, ByVal x)
    Select Case True
      Case y > 0 And x = 0 : Return Math.PI / 2
      Case y < 0 And x = 0 : Return -Math.PI / 2
      Case y > 0 And x > 0 : Return Math.Atan(y / x)
      Case y > 0 And x < 0 : Return Math.PI - Math.Atan(-y / x)
      Case y < 0 And x < 0 : Return -Math.PI + Math.Atan(y / x)
      Case y < 0 And x > 0 : Return -Math.Atan(-y / x)
    End Select
    Return 0
  End Function

  Private Sub DrawCircle(ByVal g As Graphics, ByVal p As Pen, ByVal x As Integer, ByVal y As Integer, ByVal r As Integer)
    g.DrawEllipse(p, x - r, y - r, 2 * r, 2 * r)
  End Sub

  Private Sub FillCircle(ByVal g As Graphics, ByVal b As Brush, ByVal x As Integer, ByVal y As Integer, ByVal r As Integer)
    g.FillEllipse(b, x - r, y - r, 2 * r, 2 * r)
  End Sub

  Private Sub ClearBackground()
    Dim g = Graphics.FromImage(BitMap1)
    g.Clear(bcol)
  End Sub

  Private Sub PlotBackgroundPoint(ByVal x As Integer, ByVal y As Integer, ByVal c As Color)
    x = OrgX + x
    y = OrgY - y
    If x < 0 Or x >= BitMap1.Width Or y < 0 Or y >= BitMap1.Height Then Exit Sub
    BitMap1.SetPixel(x, y, c)
  End Sub

  Private Sub PlotBackgroundLine(ByVal p As Pen, ByVal x As Integer, ByVal y As Integer)
    Dim g = Graphics.FromImage(BitMap1)
    g.TranslateTransform(OrgX, OrgY) ' set origin
    g.ScaleTransform(1, -1) ' reverse Y coords
    g.DrawLine(p, ox, oy, x, y)
    ox = x : oy = y
  End Sub

  Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
  RadioButton1.CheckedChanged, RadioButton2.CheckedChanged, RadioButton3.CheckedChanged, _
  RadioButton4.CheckedChanged, RadioButton5.CheckedChanged
    mode = Val(sender.tag)
    RePlot()
  End Sub

  Private Sub RadioButton11_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton11.CheckedChanged
    mode = NumericUpDown6.Value : RePlot()
  End Sub

  Private Sub NumericUpDown6_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown6.ValueChanged
    If mode > 4 Then mode = NumericUpDown6.Value : RePlot()
  End Sub

  Private Sub NumericUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown1.ValueChanged
    RePlot()
  End Sub

  Private Sub NumericUpDown2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown2.ValueChanged
    If NumericUpDown2.Value > 0 And NumericUpDown1.Value <= 3.98 Then NumericUpDown1.Value += 0.01
    If NumericUpDown2.Value < 0 And NumericUpDown1.Value >= 0.01 Then NumericUpDown1.Value -= 0.01
    NumericUpDown2.Value = 0
  End Sub

  Private Sub NumericUpDown3_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown3.ValueChanged
    If NumericUpDown3.Value > 0 And NumericUpDown1.Value <= 3.998 Then NumericUpDown1.Value += 0.001
    If NumericUpDown3.Value < 0 And NumericUpDown1.Value >= 0.001 Then NumericUpDown1.Value -= 0.001
    NumericUpDown3.Value = 0
  End Sub

  Private Sub NumericUpDown5_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown5.ValueChanged
    If NumericUpDown5.Value > 0 And NumericUpDown1.Value <= 3.9998 Then NumericUpDown1.Value += 0.0001
    If NumericUpDown5.Value < 0 And NumericUpDown1.Value >= 0.0001 Then NumericUpDown1.Value -= 0.0001
    NumericUpDown5.Value = 0
  End Sub

  Private Sub NumericUpDown4_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown4.ValueChanged
    RePlot()
  End Sub

  Private Sub RadioButton6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles RadioButton6.CheckedChanged, RadioButton7.CheckedChanged, RadioButton8.CheckedChanged, _
  RadioButton9.CheckedChanged, RadioButton10.CheckedChanged
    equation = Val(sender.tag) : RePlot()
  End Sub

  Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    If playtune Then
      Dim S As Single = NumericUpDown1.Value
      Dim x As Integer = Cursor.Position.X - Me.Location.X - 12 - OrgX
      x = Limit(x, 0, 640)
      A = 4 - (4 - S) * (1 - x / 640)
      p = Iterate(A, p, 1)
      Console.Beep(400 * (p + 1), 100)
    End If
  End Sub

  Private Function Limit(ByVal a, ByVal b, ByVal c)
    If a < b Then a = b
    If a > c Then a = c
    Return a
  End Function
End Class
